/* diagnostics.c generated by valac 0.46.6, the Vala compiler
 * generated from diagnostics.vala, do not modify */

/*
 * This file is part of gnome-code-assistance.
 *
 * Copyright (C) 2013 - Melissa Wen <melissa.srw@gmail.com>
 * Copyright (C) 2013 - Jesse van den Kieboom <jessevdk@gnome.org>
 *
 * gnome-code-assistance is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gnome-code-assistance is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gnome-code-assistance.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "backends/vala/libvalashared.h"

#define TYPE_DIAGNOSTICS (diagnostics_get_type ())
#define DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIAGNOSTICS, Diagnostics))
#define DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIAGNOSTICS, DiagnosticsClass))
#define IS_DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIAGNOSTICS))
#define IS_DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIAGNOSTICS))
#define DIAGNOSTICS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIAGNOSTICS, DiagnosticsClass))

typedef struct _Diagnostics Diagnostics;
typedef struct _DiagnosticsClass DiagnosticsClass;
typedef struct _DiagnosticsPrivate DiagnosticsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_Diagnostic_free0(var) ((var == NULL) ? NULL : (var = (_vala_Diagnostic_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Diagnostics {
	ValaReport parent_instance;
	DiagnosticsPrivate * priv;
};

struct _DiagnosticsClass {
	ValaReportClass parent_class;
};

struct _DiagnosticsPrivate {
	GeeHashMap* d_diagnostics;
};

static gint Diagnostics_private_offset;
static gpointer diagnostics_parent_class = NULL;

GType diagnostics_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Diagnostics, vala_report_unref)
Diagnostics* diagnostics_new (void);
Diagnostics* diagnostics_construct (GType object_type);
Diagnostic* diagnostics_diagnostics_for_path (Diagnostics* self,
                                              const gchar* path,
                                              gint* result_length1);
static void _vala_array_add1 (Diagnostic* * array,
                       int* length,
                       int* size,
                       const Diagnostic* value);
static void _vala_Diagnostic_free (Diagnostic* self);
static void _vala_Diagnostic_array_free (Diagnostic * array,
                                  gint array_length);
static void diagnostics_diags_report (Diagnostics* self,
                               ValaSourceReference* source,
                               const gchar* message,
                               Severity severity);
static Diagnostic* _diagnostic_dup (Diagnostic* self);
static void _vala_Fixit_array_free (Fixit * array,
                             gint array_length);
static void diagnostics_real_err (ValaReport* base,
                           ValaSourceReference* source,
                           const gchar* message);
static void diagnostics_real_warn (ValaReport* base,
                            ValaSourceReference* source,
                            const gchar* message);
static void diagnostics_real_depr (ValaReport* base,
                            ValaSourceReference* source,
                            const gchar* message);
static void diagnostics_real_note (ValaReport* base,
                            ValaSourceReference* source,
                            const gchar* message);
static void diagnostics_finalize (ValaReport * obj);

static inline gpointer
diagnostics_get_instance_private (Diagnostics* self)
{
	return G_STRUCT_MEMBER_P (self, Diagnostics_private_offset);
}

Diagnostics*
diagnostics_construct (GType object_type)
{
	Diagnostics* self = NULL;
	GeeHashMap* _tmp0_;
	self = (Diagnostics*) vala_report_construct (object_type);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->d_diagnostics);
	self->priv->d_diagnostics = _tmp0_;
	return self;
}

Diagnostics*
diagnostics_new (void)
{
	return diagnostics_construct (TYPE_DIAGNOSTICS);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add1 (Diagnostic* * array,
                  int* length,
                  int* size,
                  const Diagnostic* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (Diagnostic, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
_vala_Diagnostic_free (Diagnostic* self)
{
	diagnostic_destroy (self);
	g_free (self);
}

static void
_vala_Diagnostic_array_free (Diagnostic * array,
                             gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			diagnostic_destroy (&array[i]);
		}
	}
	g_free (array);
}

Diagnostic*
diagnostics_diagnostics_for_path (Diagnostics* self,
                                  const gchar* path,
                                  gint* result_length1)
{
	GeeArrayList* diagnostics = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	Diagnostic* ret = NULL;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Diagnostic* _tmp8_;
	gint ret_length1;
	gint _ret_size_;
	Diagnostic* _tmp20_;
	gint _tmp20__length1;
	Diagnostic* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->d_diagnostics;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, path);
	diagnostics = (GeeArrayList*) _tmp1_;
	_tmp2_ = diagnostics;
	if (_tmp2_ == NULL) {
		Diagnostic* _tmp3_;
		Diagnostic* _tmp4_;
		gint _tmp4__length1;
		_tmp3_ = g_new0 (Diagnostic, 0);
		_tmp4_ = _tmp3_;
		_tmp4__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp4__length1;
		}
		result = _tmp4_;
		_g_object_unref0 (diagnostics);
		return result;
	}
	_tmp5_ = diagnostics;
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_new0 (Diagnostic, _tmp7_);
	ret = _tmp8_;
	ret_length1 = _tmp7_;
	_ret_size_ = ret_length1;
	ret_length1 = 0;
	{
		GeeArrayList* _d_list = NULL;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
		gint _d_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _d_index = 0;
		_tmp9_ = diagnostics;
		_tmp10_ = _g_object_ref0 (_tmp9_);
		_d_list = _tmp10_;
		_tmp11_ = _d_list;
		_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
		_tmp13_ = _tmp12_;
		_d_size = _tmp13_;
		_d_index = -1;
		while (TRUE) {
			Diagnostic* d = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			Diagnostic* _tmp16_;
			gint _tmp16__length1;
			Diagnostic* _tmp17_;
			Diagnostic _tmp18_;
			Diagnostic _tmp19_ = {0};
			_d_index = _d_index + 1;
			if (!(_d_index < _d_size)) {
				break;
			}
			_tmp14_ = _d_list;
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _d_index);
			d = (Diagnostic*) _tmp15_;
			_tmp16_ = ret;
			_tmp16__length1 = ret_length1;
			_tmp17_ = d;
			_tmp18_ = *_tmp17_;
			diagnostic_copy (&_tmp18_, &_tmp19_);
			_vala_array_add1 (&ret, &ret_length1, &_ret_size_, &_tmp19_);
			__vala_Diagnostic_free0 (d);
		}
		_g_object_unref0 (_d_list);
	}
	_tmp20_ = ret;
	_tmp20__length1 = ret_length1;
	if (result_length1) {
		*result_length1 = _tmp20__length1;
	}
	result = _tmp20_;
	_g_object_unref0 (diagnostics);
	return result;
}

static Diagnostic*
_diagnostic_dup (Diagnostic* self)
{
	Diagnostic* dup;
	dup = g_new0 (Diagnostic, 1);
	diagnostic_copy (self, dup);
	return dup;
}

static void
_vala_Fixit_array_free (Fixit * array,
                        gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			fixit_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
diagnostics_diags_report (Diagnostics* self,
                          ValaSourceReference* source,
                          const gchar* message,
                          Severity severity)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeArrayList* diagnostics = NULL;
	GeeHashMap* _tmp8_;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_;
	GeeArrayList* _tmp14_;
	SourceLocation start = {0};
	ValaSourceLocation _tmp22_ = {0};
	ValaSourceLocation _tmp23_;
	ValaSourceLocation _tmp24_ = {0};
	ValaSourceLocation _tmp25_;
	SourceLocation _tmp26_ = {0};
	SourceLocation end = {0};
	ValaSourceLocation _tmp27_ = {0};
	ValaSourceLocation _tmp28_;
	ValaSourceLocation _tmp29_ = {0};
	ValaSourceLocation _tmp30_;
	SourceLocation _tmp31_ = {0};
	SourceLocation _tmp32_;
	SourceRange range = {0};
	SourceLocation _tmp36_;
	SourceLocation _tmp37_;
	SourceRange _tmp38_ = {0};
	GeeArrayList* _tmp39_;
	Fixit* _tmp40_;
	SourceRange _tmp41_;
	SourceRange* _tmp42_;
	gchar* _tmp43_;
	Diagnostic _tmp44_ = {0};
	Diagnostic _tmp45_;
	Diagnostic _tmp46_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	if (source == NULL) {
		_tmp1_ = TRUE;
	} else {
		ValaSourceFile* _tmp2_;
		ValaSourceFile* _tmp3_;
		_tmp2_ = vala_source_reference_get_file (source);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_ == NULL;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		ValaSourceFile* _tmp4_;
		ValaSourceFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp4_ = vala_source_reference_get_file (source);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_source_file_get_filename (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = _tmp7_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	_tmp8_ = self->priv->d_diagnostics;
	_tmp9_ = vala_source_reference_get_file (source);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_source_file_get_filename (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp12_);
	diagnostics = (GeeArrayList*) _tmp13_;
	_tmp14_ = diagnostics;
	if (_tmp14_ == NULL) {
		GeeArrayList* _tmp15_;
		GeeHashMap* _tmp16_;
		ValaSourceFile* _tmp17_;
		ValaSourceFile* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		GeeArrayList* _tmp21_;
		_tmp15_ = gee_array_list_new (TYPE_DIAGNOSTIC, (GBoxedCopyFunc) _diagnostic_dup, (GDestroyNotify) _vala_Diagnostic_free, NULL, NULL, NULL);
		_g_object_unref0 (diagnostics);
		diagnostics = _tmp15_;
		_tmp16_ = self->priv->d_diagnostics;
		_tmp17_ = vala_source_reference_get_file (source);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_source_file_get_filename (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = diagnostics;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, _tmp20_, _tmp21_);
	}
	vala_source_reference_get_begin (source, &_tmp22_);
	_tmp23_ = _tmp22_;
	vala_source_reference_get_begin (source, &_tmp24_);
	_tmp25_ = _tmp24_;
	memset (&_tmp26_, 0, sizeof (SourceLocation));
	_tmp26_.line = (gint64) _tmp23_.line;
	_tmp26_.column = (gint64) _tmp25_.column;
	start = _tmp26_;
	vala_source_reference_get_end (source, &_tmp27_);
	_tmp28_ = _tmp27_;
	vala_source_reference_get_end (source, &_tmp29_);
	_tmp30_ = _tmp29_;
	memset (&_tmp31_, 0, sizeof (SourceLocation));
	_tmp31_.line = (gint64) _tmp28_.line;
	_tmp31_.column = (gint64) _tmp30_.column;
	end = _tmp31_;
	_tmp32_ = end;
	if (source_location_compare_to (&start, &_tmp32_) > 0) {
		SourceLocation tmp = {0};
		SourceLocation _tmp33_;
		SourceLocation _tmp34_;
		SourceLocation _tmp35_;
		_tmp33_ = end;
		tmp = _tmp33_;
		_tmp34_ = start;
		end = _tmp34_;
		_tmp35_ = tmp;
		start = _tmp35_;
	}
	_tmp36_ = start;
	_tmp37_ = end;
	memset (&_tmp38_, 0, sizeof (SourceRange));
	_tmp38_.file = (gint64) 0;
	_tmp38_.start = _tmp36_;
	_tmp38_.end = _tmp37_;
	range = _tmp38_;
	_tmp39_ = diagnostics;
	_tmp40_ = g_new0 (Fixit, 0);
	_tmp41_ = range;
	_tmp42_ = g_new0 (SourceRange, 1);
	_tmp42_[0] = _tmp41_;
	_tmp43_ = g_strdup (message);
	memset (&_tmp44_, 0, sizeof (Diagnostic));
	_tmp44_.severity = (guint32) severity;
	_tmp44_.fixits = (_vala_Fixit_array_free (_tmp44_.fixits, _tmp44_.fixits_length1), NULL);
	_tmp44_.fixits = _tmp40_;
	_tmp44_.fixits_length1 = 0;
	_tmp44_.locations = (g_free (_tmp44_.locations), NULL);
	_tmp44_.locations = _tmp42_;
	_tmp44_.locations_length1 = 1;
	_g_free0 (_tmp44_.message);
	_tmp44_.message = _tmp43_;
	_tmp45_ = _tmp44_;
	_tmp46_ = _tmp45_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, &_tmp46_);
	diagnostic_destroy (&_tmp45_);
	_g_object_unref0 (diagnostics);
}

static void
diagnostics_real_err (ValaReport* base,
                      ValaSourceReference* source,
                      const gchar* message)
{
	Diagnostics * self;
	self = (Diagnostics*) base;
	g_return_if_fail (message != NULL);
	g_log ("GcaVala", G_LOG_LEVEL_DEBUG, "diagnostics.vala:103: [err]: %s", message);
	diagnostics_diags_report (self, source, message, SEVERITY_ERROR);
}

static void
diagnostics_real_warn (ValaReport* base,
                       ValaSourceReference* source,
                       const gchar* message)
{
	Diagnostics * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = (Diagnostics*) base;
	g_return_if_fail (message != NULL);
	g_log ("GcaVala", G_LOG_LEVEL_DEBUG, "diagnostics.vala:110: [warn]: %s", message);
	_tmp0_ = vala_report_get_enable_warnings ((ValaReport*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	diagnostics_diags_report (self, source, message, SEVERITY_WARNING);
}

static void
diagnostics_real_depr (ValaReport* base,
                       ValaSourceReference* source,
                       const gchar* message)
{
	Diagnostics * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = (Diagnostics*) base;
	g_return_if_fail (message != NULL);
	g_log ("GcaVala", G_LOG_LEVEL_DEBUG, "diagnostics.vala:122: [depr]: %s", message);
	_tmp0_ = vala_report_get_enable_warnings ((ValaReport*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	diagnostics_diags_report (self, source, message, SEVERITY_DEPRECATED);
}

static void
diagnostics_real_note (ValaReport* base,
                       ValaSourceReference* source,
                       const gchar* message)
{
	Diagnostics * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = (Diagnostics*) base;
	g_return_if_fail (message != NULL);
	g_log ("GcaVala", G_LOG_LEVEL_DEBUG, "diagnostics.vala:134: [note]: %s", message);
	_tmp0_ = vala_report_get_enable_warnings ((ValaReport*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	diagnostics_diags_report (self, source, message, SEVERITY_INFO);
}

static void
diagnostics_class_init (DiagnosticsClass * klass,
                        gpointer klass_data)
{
	diagnostics_parent_class = g_type_class_peek_parent (klass);
	((ValaReportClass *) klass)->finalize = diagnostics_finalize;
	g_type_class_adjust_private_offset (klass, &Diagnostics_private_offset);
	((ValaReportClass *) klass)->err = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) diagnostics_real_err;
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) diagnostics_real_warn;
	((ValaReportClass *) klass)->depr = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) diagnostics_real_depr;
	((ValaReportClass *) klass)->note = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) diagnostics_real_note;
}

static void
diagnostics_instance_init (Diagnostics * self,
                           gpointer klass)
{
	self->priv = diagnostics_get_instance_private (self);
}

static void
diagnostics_finalize (ValaReport * obj)
{
	Diagnostics * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIAGNOSTICS, Diagnostics);
	_g_object_unref0 (self->priv->d_diagnostics);
	VALA_REPORT_CLASS (diagnostics_parent_class)->finalize (obj);
}

GType
diagnostics_get_type (void)
{
	static volatile gsize diagnostics_type_id__volatile = 0;
	if (g_once_init_enter (&diagnostics_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiagnosticsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diagnostics_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Diagnostics), 0, (GInstanceInitFunc) diagnostics_instance_init, NULL };
		GType diagnostics_type_id;
		diagnostics_type_id = g_type_register_static (VALA_TYPE_REPORT, "Diagnostics", &g_define_type_info, 0);
		Diagnostics_private_offset = g_type_add_instance_private (diagnostics_type_id, sizeof (DiagnosticsPrivate));
		g_once_init_leave (&diagnostics_type_id__volatile, diagnostics_type_id);
	}
	return diagnostics_type_id__volatile;
}

